
package gus05.manager.gus.kassia.layer2.organs_impl;

import gus05.framework.features.Register;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer1.Source;
import gus05.manager.gus.kassia.layer1.organs.KeyFinder;
import gus05.manager.gus.kassia.layer2.KassiaSystem;

import java.util.Map;


public class Impl_KeyFinder implements KeyFinder {

    
    
    public String findKey(Source src) throws Exception
    {
    	String value = findValue(src);
        
        if(value==null)       throw new Exception("Invalid mapping for source ["+src+"]: null value");
        if(value.equals(""))  throw new Exception("Invalid mapping for source ["+src+"]: empty value");
        
        recordCall(src,value);
        return value;
    }
    
    
    
    
    
    private String findValue(Source src) throws Exception
    {
    	Transform t = KassiaSystem.findMappingHandler();
        if(t!=null) return (String) t.transform(toDataTab(src));
        
    	Map map = determineMap(src);
        String value = determineValue(map,src);
        if(map.containsKey(value)) return (String)map.get(value);
        return value;
    }
    
    
    
    
    private Map determineMap(Source src)
    {
        String mapID = "mapping."+src.getEntityName();
        Map m = (Map) KassiaSystem.find(mapID);
        if(m!=null) return m;
        return KassiaSystem.mapping;
    }
    
    
    
    
    private String determineValue(Map map, Source src)
    {
        String key1 = src.toString();
        if(map.containsKey(key1)) return (String)map.get(key1);
        String key2 = src.toString2();
        if(map.containsKey(key2)) return (String)map.get(key2);
        String key3 = src.toString3();
        if(map.containsKey(key3)) return (String)map.get(key3);
        return src.getId();
    }
    
    

    
    
    
    private void recordCall(Source src, String value)
    {
        try
        {
            Register r = KassiaSystem.findMappingRecorder();
            if(r!=null) r.register(src.toString(),value);
        }
        catch(Exception e)
        {KassiaSystem.err(this,"recordCall(Source,String)",e);}
    }
    
    
    
    
    private Object[] toDataTab(Source src)
    {return new Object[]{src.getEntity(),src.getId()};}
}
