package gus05.manager.gus.kassia.layer2.tools;

import gus05.manager.gus.kassia.layer2.KassiaSystem;

import java.io.File;
import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JOptionPane;

public class FatalErrorHolder {
	
	
	private PrintStream file_out;
	
	private SimpleDateFormat yyyyMMdd_HHmmss = new SimpleDateFormat("yyyyMMdd_HHmmss");
    private String timeStamp(Date date){return yyyyMMdd_HHmmss.format(date);}

    
	
	public FatalErrorHolder(String id, Exception e)
	{
		String time = timeStamp(new Date());
		initFile(time);
        
        if(file_out!=null)
        {
        	file_out.println("FATAL ERROR REPORT");
        	file_out.println("------------------");
        	file_out.println("manager ID: "+KassiaSystem.MANAGERID);
        	file_out.println("start date: "+timeStamp(KassiaSystem.appStartDate));
        	file_out.println("args line: "+KassiaSystem.appArgsLine);
        	file_out.println("------------------");
        	file_out.println("exception source "+id);
        	file_out.println("exception time: "+time);
        	file_out.println("exception type: "+e.getClass().getName());
        	file_out.println("exception message: "+e.getMessage());
        	file_out.println("------------------");
        	e.printStackTrace(file_out);
        	file_out.close();
        }

        
        System.err.println("FATAL ERROR at "+id);
        e.printStackTrace(System.err);
        System.err.println("Application will exit ...  System.exit(1)");

        String message = "FATAL ERROR at "+id+"\n"+e+"\n\nApplication will exit ...  System.exit(1)";
        showErr(message,"FATAL ERROR");
        
        System.exit(1);
	}
	
	
	
	
	private void initFile(String time)
	{
		String fileName = "fatalerr_"+time+"_"+KassiaSystem.MANAGERID+".txt";
        File file = new File(fileName); //file inside the launch dir
		
		try
		{
			file_out = new PrintStream(file);
		}
		catch(Exception e)
		{
			String message = "failed to initialize report file "+file.getAbsolutePath()+"\n"+e;
			showErr(message,"report file failure");
		}
	}
	
	
	
	
	
	
	private void showErr(String message, String title)
	{
		JOptionPane.showMessageDialog(null,message,title,JOptionPane.ERROR_MESSAGE);
	}
}
