package gus05.manager.gus.kassia.layer2.tools;

import gus05.framework.features.Provide;
import gus05.framework.features.Retrieve;

import java.io.InputStream;
import java.net.URL;
import java.util.Properties;
import java.util.Set;


public class Inside implements Retrieve, Provide {

	
	private String root;
	
	public Inside(String root)
	{
		this.root = root;
	}
	
	
	public Object provide() throws Exception
	{return root;}
	
	
    public Object retrieve(String key) throws Exception
    {
        String[] n = key.split("\\.",2);
        String type = n[0];
        String location = n[1];
        
        if(type.equals("url")) return url(location);
        if(type.equals("stream")) return stream(location);
        if(type.equals("prop")) return prop(location);
        if(type.equals("txt")) return txt(location);
        if(type.equals("listing")) return listing(location);
        
        throw new Exception("Unknown inside type: ["+type+"]");
    }
    
    
    
    public URL url(String id)
    {return getClass().getResource(root+id);}
    
    public InputStream stream(String id) throws Exception
    {
    	if(!checkDone) check(root+id);
    	return getClass().getResourceAsStream(root+id);
    }
    


    

    
    
    public Properties prop(String id) throws Exception
    {
        InputStream is = stream(id);
        if(is==null) return null;
        
        Properties p = new Properties();
        p.load(is);
        is.close();
        return p;
    }
    
    
    
    public String txt(String id) throws Exception
    {
        InputStream is = stream(id);
        if(is==null) return null;
        
        StringBuffer b = new StringBuffer();
        int c;
        while((c=is.read())!=-1)
        b.append((char)c);
        is.close();
        return b.toString();
    }
    
    
    
    public Set listing(String id) throws Exception
    {
        Properties p = prop(id+"/listing");
        if(p==null)return null;
        return p.keySet();
    }
    
    
    
    
    
    
    
    
    
    
    
    
    /*
     * If the application path contains exclamation marks '!',
     * the following sun class: sun.net.www.protocol.jar.JarURLConnection$JarURLInputStream
     * will not be successfully instantiated during the getResourceAsStream call
     */
    private boolean checkDone = false;
    
    private void check(String path) throws Exception
    {
    	URL url = getClass().getResource(path);
    	if(url==null) return;
    	if(getClass().getResourceAsStream(path)==null)
    		throw new Exception("Unable to handle jar internal URLs due to exclamation mark confusion :"+
    				"\ntroubling url example: ["+url+"]"+
    				"\nPlease remove all exclamation marks '!' from the application path");
    	checkDone = true;
    }
}
