package gus05.manager.gus.kassia.layer2.tools;


import gus05.framework.features.Filter;
import gus05.framework.features.Provide;
import gus05.framework.features.Retrieve;
import gus05.framework.tools.DefaultSupport;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;


public class SupportSet extends DefaultSupport implements Set, Retrieve, Provide, Filter {

    
    private Set set;
    private String name;
    
    private Object lastElement;
    
    
    
    
    public SupportSet(String name)
    {
        set = new HashSet();
        this.name = name;
    }
    
    
    public String toString()
    {return name;}

    
    
    

    public int size()							{return set.size();}
    public boolean isEmpty()					{return set.isEmpty();}
    public boolean contains(Object value)		{return set.contains(value);}
    public boolean containsAll(Collection c)	{return set.containsAll(c);}
    public Iterator iterator()					{return set.iterator();}
    public Object[] toArray()					{return set.toArray();}
    public Object[] toArray(Object[] array)		{return set.toArray(array);}
    public boolean equals(Object o)				{return set.equals(o);}
	
    
    
    public boolean add(Object value)
    {
        lastElement = value;
        boolean result = set.add(value);
        if(result)send(this,"add(Object)");
        return result;
    }

    
    public boolean remove(Object value)
    {
        lastElement = value;
        boolean result = set.remove(value);
        if(result)send(this,"remove(Object)");
        return result;
    }

    
    public boolean addAll(Collection c)
    {
        boolean result = set.addAll(c);    
        if(result)send(this,"addAll(Collection)");
        return result;
    }
    
    
    public boolean retainAll(Collection c)
    {
        boolean result = set.retainAll(c);    
        if(result)send(this,"retainAll(Collection)");
        return result;
    }

    
    public boolean removeAll(Collection c)
    {
        boolean result = set.removeAll(c);
        if(result)send(this,"removeAll(Collection)");
        return result;
    }

    
    public void clear()
    {
        set.clear();
        send(this,"clear()");
    }

    
    
    
    
    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("lastElement"))return lastElement;
        if(key.equals("set"))return set;

        if(key.equals("keys"))
            return new String[]{"lastElement","set"};
        
        throw new Exception("unknown key "+key);
    }
    
    
    
    public boolean filter(Object obj) throws Exception 		{return set.contains(obj);}
    public Object provide() throws Exception 				{return set;}
}
