package gus05.manager.gus.kassia.layer3;

import java.applet.Applet;
import java.applet.AudioClip;
import java.io.Closeable;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintStream;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.nio.channels.FileChannel;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.Scrollable;
import javax.swing.filechooser.FileSystemView;

import gus05.framework.core.Entity;
import gus05.framework.features.*;
import gus05.framework.tools.DefaultSupport;
import gus05.manager.gus.kassia.layer2.tools.*;




public class KS2_tool extends KS1_ref {

	
	
	/*
     * ARGUMENTS
     */
    public static boolean hasArg(String name)
    {
        name = name.toLowerCase();
        for(int i=0;i<appArgs.length;i++)
            if(appArgs[i].toLowerCase().equals(name)) return true;
        return false;
    }
    
    public static boolean hasArgs()
    {return appArgs.length>0;}
    
    public static boolean sysout() {return hasArg(ARGVALUE_SYSOUT);}
    public static boolean debug() {return hasArg(ARGVALUE_DEBUG);}
    public static boolean console() {return hasArg(ARGVALUE_CONSOLE);}
    
    
    
    
    
    /*
     * PARAMS
     */
    public static boolean hasParam(String key)
    {return params.containsKey(key);}
    
    public static String getParam(String key)
    {return (String) params.get(key);}
    
    public static boolean checkParam(String key,String value)
    {return hasParam(key) && getParam(key).equals(value);}
    
    
    
    
    /*
     * POOL
     */
    public static boolean hasPool(String key)
    {return pool.containsKey(key);}
    
    public static Object getPool(String key)
    {return hasPool(key)?pool.get(key):null;}
    
    public static void putPool(String key, Object value)
    {pool.put(key,value);}
    
    public static void putPoolMap(String key)
    {putPool(key,supMap(key));}
    
    public static void putPoolSet(String key)
    {putPool(key,supSet(key));}
    
    public static void putPoolList(String key)
    {putPool(key,supList(key));}
    
    public static void removePool(String key)
    {if(hasPool(key)) pool.remove(key);}
    
    public static Map poolmap(String key)
    {return (Map) getPool(key);}
    
    public static Set poolset(String key)
    {return (Set) getPool(key);}
    
    public static List poollist(String key)
    {return (List) getPool(key);}
    
    public static Execute poolexe(String key)
    {return (Execute) getPool(key);}
    
    public static Register poolreg(String key)
    {return (Register) getPool(key);}
    
    public static Retrieve poolret(String key)
    {return (Retrieve) getPool(key);}
    
    public static DefaultSupport poolsup(String key)
    {return (DefaultSupport) getPool(key);}
    
    public static Transform pooltran(String key)
    {return (Transform) getPool(key);}
    
    public static Give poolgive(String key)
    {return (Give) getPool(key);}
    
    public static Provide poolpro(String key)
    {return (Provide) getPool(key);}
    
    public static Filter poolfilter(String key)
    {return (Filter) getPool(key);}
    
    
    
    
    

    
    /*
     * INSIDE
     */
    public static URL insideURL(String key) throws Exception
    {return (URL) inside.retrieve("url."+key);}
    
    public static InputStream insideStream(String key) throws Exception
    {return (InputStream) inside.retrieve("stream."+key);}
    
    public static Properties insideProp(String key) throws Exception
    {return (Properties) inside.retrieve("prop."+key);}
    
    public static String insideText(String key) throws Exception
    {return (String) inside.retrieve("txt."+key);}
    
    public static Set insideListing(String key) throws Exception
    {return (Set) inside.retrieve("listing."+key);}
    
    
    
    
    
    
    /*
     * CONSTANTS
     */
    public static Map constants() throws Exception
    {
    	LockableMap map = new LockableMap("constants");
    	Field[] f = KS1_ref.class.getFields();
    	for(int i=0;i<f.length;i++)
    	{
    		Field field = f[i];
    		Class type = field.getType();
    		int m = field.getModifiers();
    		
    		if(type.equals(String.class) && Modifier.isFinal(m) && Modifier.isStatic(m))
    		{
    			String name = field.getName();
    			String value = (String) field.get(null);
    			map.put(name,value);
    		}
    	}
    	map.lock();
    	return map;
    }
    
    
    
    
    
    
    
    
    /*
     * JVM SYSTEM
     */
    public static final String SYS_JAVAVERSION = System.getProperty("java.version");
    public static final String SYS_JAVAHOME = System.getProperty("java.home");
    public static final String SYS_USERDIR = System.getProperty("user.dir");
    public static final String SYS_USERLANGUAGE = System.getProperty("user.language");
    
    public static final File DIR_SYS_USERDIR = new File(SYS_USERDIR);
    public static final File DIR_SYS_JAVAHOME = new File(SYS_JAVAHOME);
    
    public static void _(String message) {System.out.println(message);}
    
    
    
    
    
    /*
     * TIME
     */
    public static String now()						{return yyyyMMdd_HHmmss(new Date());}
    public static String today()					{return yyyyMMdd(new Date());}
    public static String thisYear()					{return yyyy(new Date());}
    public static String thisMonth()				{return MM(new Date());}
    
    public static String startDate()				{return yyyyMMdd_HHmmss(appStartDate);}
    
    public static long timeFrom(Date d)				{return millis()-d.getTime();}
    public static long timeFromStart()				{return timeFrom(appStartDate);}
    
    public static String timeFromStart_ms()			{return ms(timeFrom(appStartDate));}
    public static long millis()						{return System.currentTimeMillis();}
    
    private static long t0 = -1;
    
    public static long lapse()
    {
    	long t = t0;
    	t0 = millis();
    	if(t==-1) return timeFromStart();
    	return t0-t;
    }
    
    
    
    
    
    
    
    
    
    /*
     * STRING FORMAT
     */
    public static final SimpleDateFormat yyyyMMdd_HHmmss = new SimpleDateFormat("yyyyMMdd_HHmmss");
    public static final SimpleDateFormat yyyyMMdd = new SimpleDateFormat("yyyyMMdd");
    public static final SimpleDateFormat yyyyMM = new SimpleDateFormat("yyyyMM");
    public static final SimpleDateFormat yyyy = new SimpleDateFormat("yyyy");
    public static final SimpleDateFormat MM = new SimpleDateFormat("MM");
    public static final SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss");
    
    public static String yyyyMMdd_HHmmss(Date d)	{return yyyyMMdd_HHmmss.format(d);}
    public static String yyyyMMdd(Date d)			{return yyyyMMdd.format(d);}
    public static String yyyyMM(Date d)				{return yyyyMM.format(d);}
    public static String yyyy(Date d)				{return yyyy.format(d);}
    public static String MM(Date d)					{return MM.format(d);}
    public static String sdf1(Date d)				{return sdf1.format(d);}
    
    public static NumberFormat numberFormat = NumberFormat.getInstance();
    
    public static String ns(long value) 			{return numberFormat.format(value)+" ns";}
    public static String ms(long value) 			{return numberFormat.format(value)+" ms";}
    
    public static String formatN(String s, String c, int l)
    {while(s.length()<l) s = c+s;return s;}
    
    public static String formatN(int n, int l)
    {return formatN(""+n,"0",l);}
    
    public static String formatN2(int n)
    {return formatN(n,2);}
    
    
    
    
    
    
    
    
    
    
    /*
     * THROWABLES
     */
    public static String toString(Throwable e)
    {
    	if(e.toString().startsWith("java.lang.Exception"))
    		return e.getMessage()+" ("+location(e)+")";
    	return e.toString()+" ("+location(e)+")";
    }
    
    public static String location(Throwable e)
    {
    	StackTraceElement[] ste = e.getStackTrace();
    	if(ste.length==0) return null;
    	int n=0;
    	StackTraceElement ste_ = ste[0];
    	while(ste_.getFileName()==null && ste.length>n+1) ste_ = e.getStackTrace()[++n];
    	return ste_.getFileName()+":"+ste_.getLineNumber();
    }

    
    public static String firstCauseToString(Throwable e)
    {
    	while(e.getCause()!=null) e = e.getCause();
    	return toString(e);
    }
    
    
    
    
    public static void printMessage(Throwable e, PrintStream p)
    {
    	p.println("> MESSAGE:"+toString(e));
    }
    
    public static void printCauses(Throwable e, PrintStream p)
    {
    	p.println("> CAUSES:");
    	p.println("caused by: "+toString(e));
    	while(e.getCause()!=null)
    	{
    		e = e.getCause();
    		p.println("caused by: "+toString(e));
    	}
    }
    
    public static void printStackTrace(Throwable e, PrintStream p)
    {
    	p.println("> STACK TRACE:");
        e.printStackTrace(p);
    }
    
    
    
    
    
    
    
    
    
    
    /*
     * MAP
     */    
    public static Map supMap(String name)
    {return new SupportMap(name);}
    
    public static void increase(Map m, String key)
    {
    	Integer n = m.containsKey(key)?(Integer)m.get(key):new Integer(0);
    	n = new Integer(n.intValue()+1);
    	m.put(key,n);
    }
    
    public static void keepMax(Map m, String key, long value)
    {
    	if(m.containsKey(key))
    	{
    		Long l = (Long)m.get(key);
    		value = Math.max(value,l.longValue());
    	}
    	m.put(key,new Long(value));
    }
    
    public static void keepSum(Map m, String key, long value)
    {
    	Long l = m.containsKey(key)?(Long)m.get(key):new Long(0);
    	l = new Long(l.intValue()+value);
    	m.put(key,l);
    }
    
    
    
    
    
    
    
    
    /*
     * LIST
     */
    public static String[] toArray(String text)
    {
    	if(text.equals("")) return new String[0];
    	return text.replace("\r","").split("\n");
    }
    
    public static List list(String text)
    {
    	ArrayList list = new ArrayList();
        String[] lines = toArray(text);
        for(int i=0;i<lines.length;i++)
        list.add(lines[i]);
        return list;
    }
    
    public static List list(URL url) throws Exception
    {return list(text(url));}
    
    public static List supList(String name)
    {return new SupportList(name);}
    
    
    
    
    
    /*
     * SET
     */
    public static Set set(String text)
    {return new HashSet(list(text));}
    
    public static Set set(URL url) throws Exception
    {return set(text(url));}
    
    public static Set supSet(String name)
    {return new SupportSet(name);}
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    /*
     * FILES
     */
    public static String getResourceName(File file)
    {return getResourceName(file.getName());}
    
    public static String getResourceExtension(File file)
    {return getResourceExtension(file.getName());}
    
    public static String getResourceName(String name)
    {
        if(!name.contains(".")) return name;
        String[] n = name.split("\\.");
        int l = n[n.length-1].length();
        return name.substring(0,name.length()-1-l);
    }
    
    public static String getResourceExtension(String name)
    {
        if(!name.contains(".")) return "";
        String[] n = name.split("\\.");
        return n[n.length-1];
    }
    
    public static String display(File f)
    {
    	if(f==null) return "null";
    	if(!f.exists()) return "["+f+"] (does not exist)";
    	if(f.isFile()) return "["+f+"] (file)";
    	return "["+f+"] (dir)";
    }
    
    public static void copy(File in, File out) throws Exception
    {
    	if(in.equals(out)) return;
        out.getParentFile().mkdirs();
        
        FileInputStream fis = new FileInputStream(in);
        FileOutputStream fos = new FileOutputStream(out);
        
        FileChannel inputChannel = fis.getChannel();
        FileChannel outputChannel = fos.getChannel();
        
        outputChannel.transferFrom(inputChannel,0,in.length());
        
        fis.close();
        fos.close();
    }
    
    
    /*
     * formattage du file path pour correspondre  l'OS
     */
    public static String pathOS(String path)
    {
    	String s = File.separator;
    	path = path.replace("\\",s).replace("/",s).replace(s+s,s);
    	if(path.startsWith(s)) path = path.substring(1);
    	if(path.endsWith(s)) path = path.substring(0,path.length()-1);
    	return path;
    }
    
    public static File newFileOS(String path)
    {return new File(pathOS(path)).getAbsoluteFile();}
    
    public static File newFileOS(File dir, String path)
    {return new File(dir,pathOS(path)).getAbsoluteFile();}
    
    
    
    
    
    
    
    
    
    /*
     * FILES READING
     */
    public static String text(InputStream is) throws Exception
    {
        StringBuffer b = new StringBuffer();
        int c;
        while((c=is.read())!=-1)
        b.append((char)c);
        is.close();
        return b.toString();
    }
    
    public static Properties prop(InputStream is) throws Exception
    {
    	Properties prop = new Properties();
        prop.load(is);
        is.close();
        return prop;
    }
    
    public static Properties prop(File file) throws Exception
    {
    	Properties prop = new Properties();
        FileInputStream fis = new FileInputStream(file);
        prop.load(fis);
        fis.close();
        return prop;
    }
    
    public static String text(File file) throws Exception
    {
    	FileReader fr = new FileReader(file);
        char[] a= new char[(int)file.length()];
        fr.read(a,0,(int)file.length());
        fr.close();
        return new String(a);
    }
    
    
    
    
    
    
    /*
     * FILES WRITING
     */
    public static void writeProp(File file, Properties prop) throws Exception
    {
    	FileOutputStream fos = new FileOutputStream(file);
        prop.store(fos,"");
        fos.close();
    }
    
    public static void writeText(File file, String text) throws Exception
    {
    	writeText(new PrintStream(file),text);
    }
    
    public static void writeText(PrintStream out, String text) throws Exception
    {
    	out.println(text);
        out.close();
    }
    
    public static void writeSet(PrintStream out, Set set) throws Exception
    {
        Iterator it = set.iterator();
        while(it.hasNext())
        	out.println(it.next());
        out.close();
    }
    
    public static void writeList(PrintStream out, List list) throws Exception
    {
        for(int i=0;i<list.size();i++)
        	out.println(list.get(i));
        out.close();
    }
    
    
    
    
    
    
    
    
    
    
    /*
     * FILE FILTER
     */
    private static class ExtFileFilter implements FileFilter
    {
        private String end;
        public ExtFileFilter(String ext) {end = "."+ext.toLowerCase();}
        public boolean accept(File f)
        {return f.isFile() && f.getName().toLowerCase().endsWith(end);}
    }
    
    private static class DirFileFilter implements FileFilter
    {
        public boolean accept(File f)
        {return f.isDirectory();}
    }
    
    public static FileFilter extFileFilter(String ext)
    {return new ExtFileFilter(ext);}
    
    public static FileFilter curFileFilter = extFileFilter("cur");
    public static FileFilter icoFileFilter = extFileFilter("ico");
    public static FileFilter pngFileFilter = extFileFilter("png");
    public static FileFilter gifFileFilter = extFileFilter("gif");
    public static FileFilter jarFileFilter = extFileFilter("jar");
    public static FileFilter zipFileFilter = extFileFilter("zip");
    public static FileFilter wavFileFilter = extFileFilter("wav");
    public static FileFilter lingFileFilter = extFileFilter("ling");
    public static FileFilter propFileFilter = extFileFilter("properties");
    public static FileFilter dirFileFilter = new DirFileFilter();
    
    
    
    
    
    
    
    
    
    /*
     * FILTER
     */
    public static TrueFilter trueFilter = new TrueFilter();
    public static FalseFilter falseFilter = new FalseFilter();
    
    private static class TrueFilter implements Filter
    {public boolean filter(Object obj) throws Exception {return true;}}
    
    private static class FalseFilter implements Filter
    {public boolean filter(Object obj) throws Exception {return false;}}
    
    
    public static Filter filterCol(Collection c){return new FilterCol(c);}
    public static Filter filterMap(Map m){return new FilterMap(m);}
    
    private static class FilterCol implements Filter
    {
    	private Collection c;FilterCol(Collection c){this.c=c;}
		public boolean filter(Object obj) throws Exception
		{return c.contains(obj);}
    }
    
    private static class FilterMap implements Filter
    {
    	private Map m;FilterMap(Map m){this.m=m;}
		public boolean filter(Object obj) throws Exception
		{return m.containsKey(obj);}
    }
    
    
    
    /*
     * TRANSFORM
     */
    public static IdTransform idTransform = new IdTransform();
    
    private static class IdTransform implements Transform
    {public Object transform(Object obj) throws Exception{return obj;}}
    
    
    /*
     * GRAPHIC
     */
    public static PanelGraphic panelGraphic = new PanelGraphic();
    
    private static class PanelGraphic implements Graphic
    {public JComponent gui(){return new JPanel();}}
    
    
    
    
    
    
    
    
    
    /*
     * URL CONNECTION
     */
    public static URLConnection connect(URL url) throws Exception
    {
    	URLConnection con = url.openConnection();
    	con.connect();
    	return con;
    }

    public static void disconnect(URLConnection con)
    {
    	if(con!=null && con instanceof HttpURLConnection)
        ((HttpURLConnection)con).disconnect();
    }
    
    public static void close(Closeable c)
    {
    	try{if(c!=null)c.close();}
    	catch(IOException e){}
    }
    
    public static Properties prop(URL url) throws Exception
    {
    	URLConnection con = null;
    	InputStream is = null;
    	Properties prop = new Properties();
		
    	try
    	{
    		con = connect(url);
    		is = con.getInputStream();
    		prop.load(is);
    		close(is);
    		disconnect(con);
    	}
    	catch(IOException e)
    	{
    		close(is);
    		disconnect(con);
    		throw e;
    	}
		return prop;
    }
    
    public static String text(URL url) throws Exception
    {
    	URLConnection con = null;
    	InputStreamReader isr = null;
    	StringBuffer buffer = new StringBuffer();
        
    	try
    	{
    		con = connect(url);
    		InputStream is = con.getInputStream(); 
            isr = new InputStreamReader(is);
            int b;
            while((b = isr.read())!=-1)
            {buffer.append((char)b);}
            close(isr);
            disconnect(con);
    	}
    	catch(IOException e)
    	{
    		close(isr);
    		disconnect(con);
    		throw e;
    	}
        return buffer.toString();
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    /*
     * PRINTSTREAM
     */
    
    private static class OutputStreamNull extends OutputStream
    {
        public OutputStreamNull(){} 
        public void write(int b){}
    }
    
    public static final OutputStreamNull nullOutput = new OutputStreamNull();
    public static final PrintStream nullPrintStream = new PrintStream(nullOutput);
    
    
    
    
    
    
    
    
    
    
    
    /*
     * LING
     */
    
    public static boolean isISO639_LanguageCode(String code)
    {
    	String[] codes = Locale.getISOLanguages();
    	for(int i=0;i<codes.length;i++)
    		if(codes[i].equals(code)) return true;
    	return false;
    }
    
    public static boolean isISO3166_CountryCode(String code)
    {
    	String[] codes = Locale.getISOCountries();
    	for(int i=0;i<codes.length;i++)
    		if(codes[i].equals(code)) return true;
    	return false;
    }
    
	
	
	
    
    
	
	
	
	
	
	
	/*
	 * RESOURCES LOADING
	 */
	
    public static int number_instanciatedEntities = 0;
    
    public static Entity instanciateEntity(Class c, String name) throws Exception
    {
    	Entity entity = (Entity)c.newInstance();
    	
        String name0 = entity.getName();
        if(!name0.equals(name))
            throw new Exception("Entity name conflict o:["+name+"] i:["+name0+"]");
        
        number_instanciatedEntities++;
        return entity;
    }
    
    
    
    
    
	public static int number_loadIcon = 0;
	public static long time_loadIcon = 0;
	
	public static ImageIcon loadIcon_URL(URL url)
	{
		long t1 = System.currentTimeMillis();
		ImageIcon icon = new ImageIcon(url);
		long t2 = System.currentTimeMillis();
		
		number_loadIcon++;
		time_loadIcon += (t2-t1);
		return icon;
	}
	
	public static Icon loadIcon_File(File file)
	{
		long t1 = System.currentTimeMillis();
		Icon icon = FileSystemView.getFileSystemView().getSystemIcon(file);
		long t2 = System.currentTimeMillis();
		
		number_loadIcon++;
		time_loadIcon += (t2-t1);
		return icon;
	}
	
	
	
	
	
	
	
	public static int number_loadAudio = 0;
	public static long time_loadAudio = 0;
	
	public static AudioClip loadAudioClip(URL url)
	{
		long t1 = System.currentTimeMillis();
		AudioClip clip = Applet.newAudioClip(url);
		long t2 = System.currentTimeMillis();
		
		number_loadAudio++;
		time_loadAudio += (t2-t1);
		return clip;
	}
	
	
	
	
	
	
	
	/*
	 * GRAPHIC
	 */
	public static JComponent scroll(JComponent c)
	{
		if(c instanceof Scrollable) return new JScrollPane(c);
		return c;
	}
	
}
