package gus05.manager.gus.kassia.layer3.t01.checkjavaversion;



public class Tools_javaVersion {

    
    private static int[] currentVersion;
    
    
    private static void init()
    {
        String[] info = System.getProperty("java.version").split("[_\\.-]");

        currentVersion = new int[info.length];
        for(int i=0;i<info.length;i++)
        currentVersion[i] = convertToInt(info[i]);
    }
    
    
    
    
    private static int convertToInt(String value)
    {
        try{return Integer.parseInt(value);}
        catch(Exception e){return 0;}
    }
    
    
    
    public static boolean isJavaVersionSupported(String javaVersion) throws Exception
    {
        if(currentVersion==null) init();
        int[] testedVersion = parseJavaVersion(javaVersion);
        // return true if currentVersion is higher than or equal to tested version
        return compare(currentVersion,testedVersion);
    }

    
    private static int[] parseJavaVersion(String javaVersion) throws Exception
    {
        String[] info = javaVersion.split("[_\\.-]");
        if(info.length<3) throw new Exception("Invalid java version: "+javaVersion);
        
        int[] weigth = new int[info.length];
        for(int i=0;i<info.length;i++)
        weigth[i] = convertToInt(info[i]);
        return weigth;
    }
    
    
    private static boolean compare(int[] a, int[] b)
    {
        for(int i=0;i<Math.min(a.length,b.length);i++)
        {
            if(a[i]>b[i]) return true;
            if(a[i]<b[i]) return false;
        }
        return true;
    }
}
