package gus05.manager.gus.kassia.layer3.t02.initerrorhandler;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import gus05.manager.gus.kassia.layer3.KS3_data;

public class T02 extends KS3_data implements ActionListener {

	
	private int errNumber = 0;
	
	
	public static void initErrorHandler()
	{errors.addActionListener(new T02());}
	
	
	
	public void actionPerformed(ActionEvent e)
	{errorListChanged();}
	
	
	
	
	
	
	private void errorListChanged()
    {
		int errNumber_ = errors.size();
		if(errNumber_ == errNumber+1)
			handleLastestError();
		else
		{
			String w = "Errors list alteration detected: size has changed from "+errNumber+" to "+errNumber_;
			printW(this,"errorListChanged()",w);
		}

		errNumber = errNumber_;
		
		int limit = intProp(PROPKEY_DEBUGERRORLIMIT,-1);
        if(limit!=-1) checkLimitExceeded(limit); 
    }
	
	
	
	
	
	
	private void handleLastestError()
	{
		Object[] info = (Object[]) errors.get(errors.size()-1);
        
    	Object source = info[0];
        String id = (String) info[1];
        Exception e = (Exception) info[2];
        //Date date = (Date) info[3];
        
        String exceptionName = e.getClass().getName();
        printE(source,id,exceptionName);
        printDetail(e);
	}
	
	
	
	
	
	
	
	
	
	
	private void printDetail(Exception e)
	{
		if(isPhase_applicationExit())
		{printStackTrace(e,p_log()); return;}
		
		String printLevel = param(PARAM_EX_PRINTLEVEL, PARAMDEFAULT_EXCEPTION_PRINTLEVEL);

        if(printLevel.equals(PARAMVALUE_EX_PRINTLEVEL_CAUSES))
        {printCauses(e,p_log()); return;}
        
        if(printLevel.equals(PARAMVALUE_EX_PRINTLEVEL_MESSAGE))
        {printMessage(e,p_log()); return;}
        
        if(printLevel.equals(PARAMVALUE_EX_PRINTLEVEL_STACKTRACE))
        {printStackTrace(e,p_log()); return;}
	}
	
	
	
	
	
	
	
	
	
	private void checkLimitExceeded(int limit)
	{
    	if(errors.size() >= limit)
    	{
    		printW(this,"checkLimitExceeded()","Error limit exceeded: limit="+limit+" error number="+errors.size());
    		printW(this,"checkLimitExceeded()","Exiting application");
    		
    		String message = "Too many errors have occurred: "+errors.size()+"\nExiting application";
    		JOptionPane.showMessageDialog(null,message,"Exiting application",JOptionPane.ERROR_MESSAGE);
    		forceExit();
    	}
	}
}
