package gus05.manager.gus.kassia.layer3.t03.initexecuteexit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import gus05.framework.features.Execute;
import gus05.framework.features.Filter;
import gus05.framework.features.Support;
import gus05.framework.tools.DefaultSupport;
import gus05.manager.gus.kassia.layer3.KS3_data;

public class T03 extends KS3_data implements Execute {

	

	public static void initExecuteExit()
	{putPool(POOL_EXECUTE_EXIT,new T03());}
	
	

	public void execute() throws Exception
	{exit_();}
	
	
	

    private void exit_()
    {
        if(!confirmExit()) return;
        nextPhase_applicationExit();
        
        DefaultSupport s1 = supportExit();
        if(s1!=null) handleSupportExit("SupportExit",s1);
        else printW_("SupportExit not found inside pool");

        DefaultSupport s2 = supportExit2();
        if(s2!=null) handleSupportExit("SupportExit2",s2);
        else printW_("SupportExit2 not found inside pool");

        boolean t = handleExitTrigger();
        if(!t)lastTimeBeforeSystemExit();
    }
    
    
    
    
    
    
    
    
    private void printM_(String m)
    {printM(this,"exit_()",m);}
    
    private void printW_(String m)
    {printW(this,"exit_()",m);}
    
    
    
    private boolean confirmExit()
    {
        try
        {
            Filter f = (Filter) findElement(POOL_FILTER_CONFIRMEXIT);
            if(f!=null) return f.filter(null);
        }
        catch(Exception e)
        {err(this,"confirmExit()",e);}
        return true;
    }
    
    
    
    
    private void handleSupportExit(String level, DefaultSupport s)
    {
    	int n = s.listeners().size();
    	String message = n==0?"no task found":"sending exit event ("+n+" tasks found)";
    	printM(this,"handleSupportExit(String,DefaultSupport)",level+": "+message);
    	if(n>0) s.send(this,"exit");
    }
    
    
    
    
    
    private boolean handleExitTrigger()
    {
    	try
        {
    		Object trigger = findElement(POOL_OBJ_EXITTRIGGER);
    		if(trigger==null) return false;
    		
    		((Support)trigger).addActionListener(new ActionListener() {
    			public void actionPerformed(ActionEvent e)
    			{lastTimeBeforeSystemExit();}
    		});
    		printM(this,"handleExitTrigger()","starting exit trigger");
        	((Execute)trigger).execute();
        	return true;
        }
    	catch(Exception e)
        {err(this,"handleExitTrigger()",e);}
    	return false;
    }
    
    
    
    
    
    
    
    
    private void lastTimeBeforeSystemExit()
    {
    	executeBeforeExit();
        int nbErrors = errors.size();
        if(nbErrors>0) printM_("Errors number: "+nbErrors);
        
        printM_("Time from start: "+timeFromStart_ms());
        printM_("System.exit(0)");
        System.exit(0);
    }
    
    private void executeBeforeExit()
    {
    	try
        {
    		Execute exBeExit = (Execute) findElement(POOL_EXECUTE_BEFOREXIT);
    		if(exBeExit==null) return;
    		printM(this,"executeBeforeExit()","execute");
    		exBeExit.execute();
        }
        catch(Exception e)
        {err(this,"executeBeforeExit()",e);}
    }
}
