package gus05.manager.gus.kassia.layer3.t09.loadproperties;

import java.io.File;
import java.net.URL;
import java.util.Iterator;
import java.util.Properties;

import gus05.manager.gus.kassia.layer3.KS3_data;

public class T09 extends KS3_data {

	
	public static void loadProperties()
	{
		loadProperties_fromParams1();
		loadProperties_fromPropFile();
		loadProperties_fromParams2();
		loadProperties_fromSequence();
		loadProperties_fromParams3();
		
		autoExit_prop();
	}
	
	
	
	
	
	
	private static void loadProperties_fromParams1()
    {
		loadProperties_fromParams("p1");
    	if(hasParam(PARAM_ROOT))
    	{
    		String root = getParam(PARAM_ROOT);
    		setProperty_param(FILEID_ROOTDIR,root);
    	}
    }
	
	
	
	private static void loadProperties_fromParams2()
    {loadProperties_fromParams("p2");}
	
	
	
	private static void loadProperties_fromParams3()
    {loadProperties_fromParams("p3");}
	
	
	
	private static void loadProperties_fromParams(String p)
    {
    	Iterator it = params.keySet().iterator();
    	while(it.hasNext())
    	{
    		String key = (String) it.next();
    		if(key.startsWith(p+"."))
    		{
    			String value = getParam(key);
    			String key0 = key.substring(3);
    			setProperty_param(key0,value);
    		}
    	}
    }
	
	
	
	
	
	private static void loadProperties_fromPropFile()
    {
		try
		{
			File f = findPropFile();
			map_files().put(FILEID_PROPFILE,f);
	    	loadProperties_file(f);
		}
		catch(Exception e)
		{err(T09.class,"loadProperties_fromPropFile()",e);}
    }
	
	
	
	
	private static File findPropFile()
	{
		File f = file(FILEID_PROPFILE);
		if(f!=null) return f;
		File d = file(FILEID_ROOTDIR);
		if(d!=null) return new File(d,FILENAME_PROP);
		return new File(DIR_SYS_USERDIR,FILENAME_PROP);
	}
	
	
	
    
	

	private static void loadProperties_fromSequence()
	{
		try
		{
			if(!hasProp(PROPKEY_SEQUENCE_LOADPROP)) return;
			String seq = getProp(PROPKEY_SEQUENCE_LOADPROP);
			if(seq.equals("")) return;

			String[] sequence = seq.split(";");
			for(int i=0;i<sequence.length;i++)
			{
				String s = sequence[i];
				if(s.startsWith("path."))
				{
					File f = propID_toFile(s);
					loadProperties_file(f);
				}
				else if(s.startsWith("url."))
				{
					URL url = propID_toURL(s);
					loadProperties_url(url);
				}
				else if(s.startsWith("inside."))
				{
					Properties p = propID_inside(s);
					loadProperties_inside(p,s);
				}
				else throw new Exception("Invalid prop sequence: ["+seq+"]");
			}
		}
		catch(Exception e)
		{err(T09.class,"loadProperties_fromSequence()",e);}
    }
	
	
	
	
	
	
	
	
	
	
	private static void setProperty_param(String key, String value)
	{
		if(key.equals("")) return;
		setProp(key,value);
		printM(T09.class,"setProperties_param(String,String)","Property setted: ["+key+"="+value+"]");
	}
	
	private static void loadProperties_file(File f) throws Exception
    {
		if(f==null || !f.exists()) return;
		Properties p = prop(f);
		if(p.isEmpty()) return;
		addProp(p);
    	printM(T09.class,"loadProperties_file(File)","Prop file loaded: ["+f+"]");
	}
	
    private static void loadProperties_url(URL url) throws Exception
    {
    	if(url==null) return;
    	Properties p = prop(url);
    	if(p.isEmpty()) return;
    	addProp(p);
    	printM(T09.class,"loadProperties_url(URL)","URL Prop loaded: ["+url+"]");
    }
    
    private static void loadProperties_inside(Properties p, String location) throws Exception
    {
    	if(p==null || p.isEmpty()) return;
    	addProp(p);
    	printM(T09.class,"loadProperties_inside(Properties,String)","Inside Prop loaded: ["+location+"]");
    }
    
    
    
    
    
    
    
    
    
    private static File propID_toFile(String path) throws Exception
    {
    	File f = file(path);
    	if(f==null) throw new Exception("Property loading failed: file id not found: ["+path+"]");
    	return f;
    }
    
    private static URL propID_toURL(String key) throws Exception
    {
    	if(!hasProp(key)) throw new Exception("Property loading failed: url id not found: ["+key+"]");
    	return new URL(getProp(key));
    }
    
    private static Properties propID_inside(String id) throws Exception
    {
    	String path = id.substring("inside.".length());
    	return insideProp(path);
    }
    
    
    
    
    
    
    private static void autoExit_prop()
    {if(booleanProp(PROPKEY_DEBUGAUTOEXIT,false)) forceExit();}
    
}
