package gus05.manager.gus.kassia.layer3.t11.loadsounds;

import java.applet.AudioClip;
import java.io.File;
import java.net.URL;
import java.util.Iterator;
import java.util.Set;

import gus05.manager.gus.kassia.layer3.tools.AbstractResourceLoader;


public class T11 extends AbstractResourceLoader {

	
	
	public static void loadSounds() throws Exception
    {
		putPoolMap(POOL_MAP_SOUNDS);
        
		new T11().load("sound",PROPKEY_SEQUENCE_LOADSOUND,RESOURCEPATH_SOUND);
    }
	
	
	
	

	protected void load_fromInside_(int index, String resourceID) throws Exception
	{
		Set set = insideListing(resourceID);
		if(set==null) return;

		Iterator it = set.iterator();
		while(it.hasNext())
		{
			String key = (String)it.next();
			URL url = insideURL(resourceID+"/"+key);
			String name = getResourceName(key);
			loadSound(name,url);
		}
	}
    
    
    
    

	protected void load_fromPathID_(int index, String pathID) throws Exception
	{
		File f = file(pathID);
		if(f!=null && f.exists())
		{
			if(f.isDirectory())
				loadSound_fromDir(f);
			else if(f.isFile())
			{
				if(wavFileFilter.accept(f)) loadSound_fromFile(f);
			}
		}
	}


    


    
    
    
    
    private void loadSound_fromDir(File dir) throws Exception
    {
    	File[] sounds = dir.listFiles(wavFileFilter);
    	for(int i=0;i<sounds.length;i++) loadSound_fromFile(sounds[i]);
    }
    
    
    
    private void loadSound_fromFile(File f) throws Exception
    {
    	String name = getResourceName(f);
    	URL url = f.toURI().toURL();
        loadSound(name,url);
    }
    
    
    private void loadSound(String name, URL url)
    {
    	AudioClip0 clip = new AudioClip0(url);
        map_sounds().put(name,clip);
    }
    
    
    private boolean isSoundEnabled()
    {return booleanProp(PROPKEY_APPSOUNDENABLED,true);}
	
    
    private class AudioClip0 implements AudioClip
    {
    	private URL url;
        private AudioClip clip;
        
        public AudioClip0(URL url)
        {this.url = url;}
        
        private void init()
        {if(clip==null)clip = loadAudioClip(url);}
        
        public void loop() {if(isSoundEnabled()){init(); clip.loop();}}
        public void play() {if(isSoundEnabled()){init(); clip.play();}}
        public void stop() {init(); clip.stop();}
    }
}
