package gus05.manager.gus.kassia.layer3.t16.initentitygenerator;


import gus05.framework.core.Entity;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS3_data;

public class T16 extends KS3_data implements Retrieve, Transform {

	
	
	
	public static void initEntityGenerator() throws Exception
    {
        putPoolMap(POOL_MAP_ENTITYINSTANCENUMBERS);
        putPoolMap(POOL_MAP_ENTITYCREATIONDATES);
        putPoolMap(POOL_MAP_ENTITYLASTUSEDDATES);
        putPoolMap(POOL_MAP_ENTITYLASTBUILDTIMES);
        putPoolMap(POOL_MAP_ENTITYMAXBUILDTIMES);
        putPoolMap(POOL_MAP_ENTITYSUMBUILDTIMES);
        putPoolMap(POOL_MAP_ENTITYCREATIONTRACK);
        
        putPool(POOL_RETRIEVE_ENTITYGENERATOR,new T16());
    }
    
	
	

	
	public Object retrieve(String key) throws Exception
	{return createEntity_(key);}
	
	public Object transform(Object obj) throws Exception
	{return createEntity_((String)obj);}
	
	
	
    
    
    
    
	
    
    private Entity createEntity_(String name) throws Exception
    {
    	if(name==null) throw new Exception("Attempt to create entity with null name");
    	if(name.equals("")) throw new Exception("Attempt to create entity with empty name");
    	
    	Class c = null;
    	
        try
        {
        	long t1 = System.nanoTime();
        	map_creationTrack().put(""+t1,">"+name);
        	
        	c = retrieveEntityClass(name);
        	
        	map_lastUsedDates().put(name,now());
        	
        	Entity entity = instanciateEntity(c,name);
        	
        	long t2 = System.nanoTime();
        	map_creationTrack().put(""+t2,"<"+name);
        	
        	String creation = entity.getCreationDate();
            long buildTime = t2-t1;
            
            map_creationDates().put(name,creation);
            map_lastBuildTime().put(name,buildTime);
            keepMax(map_maxBuildTime(),name,buildTime);
            keepSum(map_sumBuildTime(),name,buildTime);
            increase(map_instanceNumber(),name);
            
            return entity;
        }
        catch(Exception e)
        {
        	String errorType = c==null?"?":"#";
        	String trackMessage = errorType+name+"    ("+firstCauseToString(e)+")";
        	
        	map_creationTrack().put(""+System.nanoTime(),trackMessage);
            map_lastBuildTime().put(name,-1L);
            
            String message = "Entity creation failed: ["+name+"]";
            throw new Exception(message,e);
        }
    }
    
    
    
    
    
    
    private Class retrieveEntityClass(String name) throws Exception
    {
    	Retrieve holder = entityClassHolder();
    	if(holder==null) throw new Exception("No entity class holder available inside pool");
    	
    	Class c = (Class) holder.retrieve(name);
    	if(c==null) throw new Exception("Class not found for entity: ["+name+"]");
    	return c;
    }
}
