package gus05.manager.gus.kassia.layer3.t21.initentityclassloader_jar;

import gus05.framework.core.Entity;
import gus05.framework.features.Retrieve;

import java.io.File;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Enumeration;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;


public class EntityClassLoader_jar implements Retrieve {

	
	private File jarFile;
	private JarFile jar;
	private URLClassLoader loader;
	
	
	public EntityClassLoader_jar(File jarFile) throws Exception
	{this.jarFile = jarFile;}
	
	
	private void initLoader() throws Exception
	{
	    jar = new JarFile(jarFile,true,JarFile.OPEN_READ);
	    loader = new URLClassLoader(new URL[]{jarFile.toURI().toURL()});
	}
	
	
	
	
	
	public Object retrieve(String key) throws Exception
	{
		try
		{
			initLoader();
			Class c = loadEntityClass(key);
			jar.close();
			return c;
		}
		catch(Exception e)
		{
			if(jar!=null) jar.close();
			throw e;
		}
	}
	
	
	
	
	private Class loadEntityClass(String name) throws Exception
	{
		String rootPath = ("gus05.entity."+name).replace(".","/");
		
	    Enumeration en = jar.entries();
	    while(en.hasMoreElements())
	    {
	        JarEntry entry = (JarEntry) en.nextElement();
	        String n = entry.getName();
	        if(n.startsWith(rootPath) && n.endsWith(".class") && !n.contains("$"))
	        {
	            String classpath = formatClasspath(n);
	            Class c = loader.loadClass(classpath);
	            if(Entity.class.isAssignableFrom(c)) return c;
	        }
	    }
	    throw new Exception("Class for entity ["+name+"] could not be found inside jar: ["+jarFile+"]");
	}
	


	private String formatClasspath(String name)
	{
		int l = name.length();
		return name.substring(0,l-6).replace("/",".");
	}
}
