package gus05.manager.gus.kassia.layer3.t25.initdatabuilder;

import gus05.framework.features.Filter;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.framework.tools.DefaultSupport;

import java.util.Collection;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

public abstract class Map1 extends DefaultSupport implements Map, Retrieve, Register, Transform, Provide, Filter
{
    protected Properties prop;
    protected String id;
    public String toString() {return id;}
    
    private String keyName = null;
    private String valueName = null;
    
    private Class keyClass = null;
    private Class valueClass = null;
    
    
    private Object lastElement;
    private Object lastResult;
    private Object lastKey;

	protected abstract void modified(String eventID);
	protected abstract void save(Object obj) throws Exception;
    
    
    public Map1(String id, Properties prop)
    {
    	this.id = id;
    	this.prop = prop;
    }
    
    public int size()                           {return prop.size();}
    public boolean isEmpty()                    {return prop.isEmpty();}
    public boolean containsKey(Object key)      {return prop.containsKey(key);}
    public boolean containsValue(Object value)  {return prop.containsValue(value);}
    public Set keySet()                         {return prop.keySet();}
    public Collection values()                  {return prop.values();}
    public Set entrySet()                       {return prop.entrySet();}
    public Object get(Object key)               {return prop.get(key);}
    public boolean equals(Object o)             {return prop.equals(o);}
    
    
    
    public Object put(Object key, Object value)
    {
        lastKey = key;
        lastElement = value;
        lastResult = prop.put(key,value);
        modified("put(Object,Object)");
        return lastResult;
    }
    
    public Object remove(Object key)
    {
        lastKey = key;
        lastResult = prop.remove(key);
        modified("remove(Object)");
        return lastResult;
    }

    public void putAll(Map m)
    {
        prop.putAll(m);
        modified("putAll(Map)");
    }
    
    public void clear()
    {
        prop.clear();
        modified("clear()");
    }
    
    

    public Object retrieve(String key) throws Exception
    {
        if(key.equals("lastElement"))return lastElement;
        if(key.equals("lastResult"))return lastResult;
        if(key.equals("lastKey"))return lastKey;
        if(key.equals("map"))return prop;
        
        if(key.equals("keyName"))return keyName;
        if(key.equals("valueName"))return valueName;
        if(key.equals("keyClass"))return keyClass;
        if(key.equals("valueClass"))return valueClass;
        
        if(key.equals("keys"))
            return new String[]{"lastElement","lastResult","lastKey","map","keyName","valueName","keyClass","valueClass"};
        
        throw new Exception("unknown key "+key);
    }


    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("keyName"))       {keyName = (String)obj;return;}
        if(key.equals("valueName"))     {valueName = (String)obj;return;}
        if(key.equals("keyClass"))      {keyClass = (Class)obj;return;}
        if(key.equals("valueClass"))    {valueClass = (Class)obj;return;}
        if(key.equals("save")) 			{save(obj);return;}
        
        throw new Exception("unknown key "+key);
    }

    public boolean filter(Object obj) throws Exception      {return prop.containsKey(obj);}
    public Object transform(Object obj) throws Exception    {return prop.get(obj);}
    public Object provide() throws Exception                {return prop;}
}
