package gus05.manager.gus.kassia.layer3.t27.initdatapersistence;




import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Timer;
import java.util.TimerTask;

import gus05.framework.features.Give;
import gus05.framework.features.Execute;
import gus05.framework.features.Register;
import gus05.manager.gus.kassia.layer3.KS3_data;



public class T27 extends KS3_data implements Give, Execute {

	
	
	public static void initDataPersistence() throws Exception
	{putPool(POOL_GIVE_DATAPERSISTENCE,new T27());}

	
	public static final long DEFAULTSAVEPOLICY = 0;
	
	private HashSet waiting;
	private long savePolicy;
	
	
	
	public void give(Object obj) throws Exception
	{
		if(waiting==null) init();
		addWaiting((String) obj);
	}
	
	
	private synchronized void addWaiting(String id)
	{waiting.add(id);}
	
	
	
	
	
	
	
	private void init()
	{
		waiting = new HashSet();
		savePolicy = longProp(PROPKEY_APPDATASAVEPOLICY,DEFAULTSAVEPOLICY);
		
		if(savePolicy>0)
        {
        	TimerTask task = new TimerTask(){public void run() {saveAll();}};
        	Timer timer = new Timer("KASSIATIMER_DataPersistence");
        	timer.schedule(task,new Date(),savePolicy);
        }
        if(savePolicy>=0)
        {
        	supportExit2().addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e)
				{saveAll();}
			});
        }    
	}
	
	
	
	
	

	public void execute() throws Exception
	{saveAll();}
	
	
	
	private synchronized void saveAll()
	{
		if(waiting==null) return;
		Iterator it = waiting.iterator();
		while(it.hasNext())
		{
			String id = (String) it.next();
			saveData(id);
		}
		waiting.clear();
	}
	
	
	
	
	private void saveData(String id)
	{
		try
		{
			if(!map_dataObject().containsKey(id)) throw new Exception("Unknown dataID: ["+id+"]");
			if(!map_dataSource().containsKey(id)) throw new Exception("Source not found for dataID: ["+id+"]");
			
			Object data = map_dataObject().get(id);
			Object source = map_dataSource().get(id);
			
			if(!(data instanceof Register)) throw new Exception("DataID ["+id+"] is not a Register object");
			Register reg = (Register) data;
        	
			Give g = dataBackup();
			if(g!=null) g.give(id);
			
			synchronized(reg) {reg.register("save",source);}
		}
		catch(Exception e)
		{err(this,"saveData(String)",e);}
	}
}
