package gus05.manager.gus.kassia.layer3.t28.initdatabackup;



import java.io.File;
import java.util.HashSet;

import gus05.framework.features.Give;
import gus05.manager.gus.kassia.layer3.KS3_data;



public class T28 extends KS3_data implements Give {

	
	
	public static void initDataBackup() throws Exception
	{putPool(POOL_GIVE_DATABACKUP,new T28());}

	
	
	
	
	
	public void give(Object obj) throws Exception
	{
		String id = (String) obj;
		
		String sourceName = id.split("#",2)[1];
		if(!rule().contains(";"+sourceName+";")) return;
		if(!firstTime(sourceName)) return;
		
		
		Object src = map_dataSource().get(id);
		backupSource(src);
	}
	
	
	
	
	private HashSet set= new HashSet();
	
	private boolean firstTime(String id)
	{return set.add(id);}
	
	
	private String rule()
	{
		String p = getProp(PROPKEY_APPBACKUPLIST,"");
		return ";"+p+";";
	}
	
	
	
	
	
	private void backupSource(Object src) throws Exception
	{
		if(src instanceof File)
			backupFile((File)src);
		else throw new Exception("Invalid source type for backup: ["+src.getClass().getName()+"]");
	}
	
	
	
	
	private void backupFile(File file) throws Exception
	{
		if(backupDir==null) initBackupDir();
		if(backupDir==null || !backupDir.exists()) return;

		File backupFile = new File(backupDir,now()+"_"+file.getName());
		copy(file,backupFile);
		printM(this,"backupFile(File)","Backuped file: ["+file+"]");
	}
	
	
	
	private File backupDir;
	private boolean initialized = false;
	
	private void initBackupDir() throws Exception
	{
		if(initialized) return;
		initialized = true;
		
		backupDir = file(FILEID_BACKUPDIR);
		if(backupDir==null) throw new Exception("fileID "+FILEID_BACKUPDIR+" not found");
		if(!backupDir.exists()) initDir(backupDir);
		if(!backupDir.exists()) throw new Exception("backupDir does not exist: ["+backupDir+"]");
	}
}
