package gus05.manager.gus.kassia.layer3.t30.initactionbuilder;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;

import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Retrieve;
import gus05.framework.resources.ActionBuilder;
import gus05.manager.gus.kassia.layer3.KS3_data;



public class T30 extends KS3_data implements ActionBuilder {

	
	
	public static void initActionBuilder()
	{
		putPool(POOL_ACTIONBUILDER,new T30());
	}

	
	
	public Action build(String key, Execute execute)
	{return new Action1(key,execute);}
	
	
	
	
	private class Action1 extends AbstractAction implements Retrieve
    {
        private String actionKey;
        private Execute execute;
        private String actionId;
        
        public Action1(String actionKey, Execute execute)
        {
            this.actionKey = actionKey;
            this.execute = execute;
            actionId = actionKey;
            
            handleAction(this);
        }
        
        public void actionPerformed(ActionEvent e)
        {execute(actionId,execute);}
        
        public String toString()
        {return actionId;}
		
		public Object retrieve(String key) throws Exception
		{
			if(key.equals("execute")) return execute;
			if(key.equals("entity")) return null;
			if(key.equals("actionKey")) return actionKey;
			if(key.equals("actionId")) return actionId;
			
			if(key.equals("keys"))
				return new String[]{"execute","entity","actionKey","actionId"};
			throw new Exception("Unknown key: ["+key+"]");
		}
    }
    
    
    
    
    
    
    
    private void execute(String actionId, Execute exe)
    {
    	try{exe.execute();}
        catch(Exception e)
        {
        	String message = "Action ID=["+actionId+"] failed to execute";
			err(this,"execute(String,Execute)",new Exception(message,e));
        }
    }
    
    
    
    
    
    private void handleAction(Action action)
    {
    	try
    	{
    		Give g = poolgive(POOL_GIVE_ACTIONHANDLER);
    		if(g!=null) g.give(action);
    	}
    	catch(Exception e)
    	{err(this,"handleAction(Action)",e);}
    }
}
