package gus05.manager.gus.kassia.layer3.t32.initactionupdater;


import javax.swing.Action;
import javax.swing.Icon;

import gus05.framework.features.Give;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS3_data;



public class T32 extends KS3_data implements Give {

	
	
	public static void initActionUpdater()
	{putPool(POOL_GIVE_ACTIONUPDATER,new T32());}

	
	
	public void give(Object obj) throws Exception
	{updateAction((Action)obj);}
	
	
	
	
	private void updateAction(Action action) throws Exception
	{
		try
		{
			String[] infos = buildInfos(action);
			if(infos.length!=4) throw new Exception("Wrong info number for action: "+action+" ("+infos.length+" infos found)");
			
			String entityName = infos[0];
			String nameKey = infos[1];
			String descKey = infos[2];
			String iconID = infos[3];
			
			String actionName = entityName!=null?ling(entityName,nameKey):ling(nameKey);
			String actionDesc = entityName!=null?ling(entityName,descKey):ling(descKey);
			Icon actionIcon = entityName!=null?icon1(entityName,iconID):icon1(iconID);
			
			action.putValue(Action.NAME,actionName);
			action.putValue(Action.SHORT_DESCRIPTION,actionDesc);
			action.putValue(Action.SMALL_ICON,actionIcon);
		}
		catch(Exception e)
		{
			String message = "Action update failed: ["+action+"]";
            throw new Exception(message,e);
		}
	}
	

	
	
	
	private String[] buildInfos(Action action) throws Exception
	{
		Transform t = pooltran(POOL_TRANSFORM_ACTIONINFOBUILDER);
		if(t==null) throw new Exception("ActionInfoBuilder not available inside pool");
		return (String[]) t.transform(action);
	}
	
}
