package gus05.manager.gus.kassia.layer3.t33.initactioninfobuilder;


import java.util.Map;

import javax.swing.Action;

import gus05.framework.core.Entity;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS3_data;



public class T33 extends KS3_data implements Transform {

	
	
	public static void initActionInfoBuilder()
	{putPool(POOL_TRANSFORM_ACTIONINFOBUILDER,new T33());}

	

	public Object transform(Object obj) throws Exception
	{return findInfos((Action)obj);}
	
	
	
	
	
	
	
	
	private String[] findInfos(Action action) throws Exception
	{
		Retrieve r = (Retrieve) action;
		
		Entity entity = (Entity) r.retrieve("entity");
		String actionKey = (String) r.retrieve("actionKey");
		String actionId = (String) r.retrieve("actionId");
		
		if(entity!=null) return findInfos(entity,actionKey,actionId);
		else return findInfos(actionKey);
	}
	
	
	
	
	
	
	
	
	private String[] findInfos(Entity entity, String actionKey, String actionId) throws Exception
	{
		String entityName = entity.getName();
		
		String rule = searchForRule(actionId,actionKey);
		String ruleIcon = iconPart(rule);
		String ruleLing = labelPart(rule);
		
		String iconID = findIconID(entityName,ruleIcon,actionKey);
		String nameKey = findNameKey(entityName,ruleLing,actionKey);
		String descKey = findDescKey(entityName,ruleLing,actionKey);
		
		return new String[]{entityName,nameKey,descKey,iconID};
	}
	
	
	
	
	
	
	
	
	
	private String[] findInfos(String actionKey) throws Exception
	{
		String rule = searchForRule(actionKey);
		String ruleIcon = iconPart(rule);
		String ruleLing = labelPart(rule);
		
		String iconID = findIconID(ruleIcon,actionKey);
		String nameKey = findNameKey(ruleLing,actionKey);
		String descKey = findDescKey(ruleLing,actionKey);
		
		return new String[]{null,nameKey,descKey,iconID};
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	private String searchForRule(String actionId, String actionKey) throws Exception
	{
		if(!hasProp(PROPKEY_ACTIONINFOMAP)) return actionKey;
		String dataID = getProp(PROPKEY_ACTIONINFOMAP);
		Map map = getDataMap(dataID);
		
		if(map.containsKey(actionId)) return (String) map.get(actionId);
		if(map.containsKey(actionKey)) return (String) map.get(actionKey);
		return actionKey;
	}
	
	private String searchForRule(String actionKey) throws Exception
	{
		if(!hasProp(PROPKEY_ACTIONINFOMAP)) return actionKey;
		String dataID = getProp(PROPKEY_ACTIONINFOMAP);
		Map map = getDataMap(dataID);
		
		if(map.containsKey(actionKey)) return (String) map.get(actionKey);
		return actionKey;
	}
	
	
	
	
	
	
	
	
	private String findIconID(String entityName, String ruleIcon, String actionKey)
	{
		if(hasIcon(entityName,ruleIcon)) return ruleIcon;
		if(hasIcon(entityName,actionKey)) return actionKey;
		if(hasIcon(entityName,iconPart(actionKey))) return actionKey;
		return ICONID_DEFAULT;
	}
	
	private String findIconID(String ruleIcon, String actionKey)
	{
		if(hasIcon(ruleIcon)) return ruleIcon;
		if(hasIcon(actionKey)) return actionKey;
		if(hasIcon(iconPart(actionKey))) return actionKey;
		return ICONID_DEFAULT;
	}
	
	
	
	
	
	
	
	private String findNameKey(String entityName, String ruleLing, String actionKey)
	{
		if(hasLing(entityName,LINGTAG_ACTIONNAME+ruleLing)) return LINGTAG_ACTIONNAME+ruleLing;
		if(hasLing(entityName,LINGTAG_ACTIONNAME+actionKey)) return LINGTAG_ACTIONNAME+actionKey;
		if(hasLing(entityName,ruleLing)) return ruleLing;
		if(hasLing(entityName,actionKey)) return actionKey;
		return ruleLing;
	}
	
	private String findNameKey(String ruleLing, String actionKey)
	{
		if(hasLing(LINGTAG_ACTIONNAME+ruleLing)) return LINGTAG_ACTIONNAME+ruleLing;
		if(hasLing(LINGTAG_ACTIONNAME+actionKey)) return LINGTAG_ACTIONNAME+actionKey;
		if(hasLing(ruleLing)) return ruleLing;
		if(hasLing(actionKey)) return actionKey;
		return ruleLing;
	}
	
	
	
	
	
	
	
	private String findDescKey(String entityName, String ruleLing, String actionKey)
	{
		if(hasLing(entityName,LINGTAG_ACTIONDESC+ruleLing)) return LINGTAG_ACTIONDESC+ruleLing;
		if(hasLing(entityName,LINGTAG_ACTIONDESC+actionKey)) return LINGTAG_ACTIONDESC+actionKey;
		if(hasLing(entityName,LINGTAG_ACTIONNAME+ruleLing)) return LINGTAG_ACTIONNAME+ruleLing;
		if(hasLing(entityName,LINGTAG_ACTIONNAME+actionKey)) return LINGTAG_ACTIONNAME+actionKey;
		if(hasLing(entityName,ruleLing)) return ruleLing;
		if(hasLing(entityName,actionKey)) return actionKey;
		return "";
	}
	
	private String findDescKey(String ruleLing, String actionKey)
	{
		if(hasLing(LINGTAG_ACTIONDESC+ruleLing)) return LINGTAG_ACTIONDESC+ruleLing;
		if(hasLing(LINGTAG_ACTIONDESC+actionKey)) return LINGTAG_ACTIONDESC+actionKey;
		if(hasLing(LINGTAG_ACTIONNAME+ruleLing)) return LINGTAG_ACTIONNAME+ruleLing;
		if(hasLing(LINGTAG_ACTIONNAME+actionKey)) return LINGTAG_ACTIONNAME+actionKey;
		if(hasLing(ruleLing)) return ruleLing;
		if(hasLing(actionKey)) return actionKey;
		return "";
	}
	
	
	
	
	
	
	
	private String iconPart(String value)
	{
		String[] n = value.split("#",2);
		return n.length==2?n[0]:null;
	}
	
	private String labelPart(String value)
	{
		String[] n = value.split("#",2);
		return n.length==2?n[1]:n[0];
	}
}
