package gus05.manager.gus.kassia.layer3.t35.initresourceprovider.basic;


import java.net.URL;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.features.Retrieve;
import gus05.manager.gus.kassia.layer3.KS3_data;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class T35 extends KS3_data {

	
	
	public static void initResourceProvider_basic()
	{
		Map m = map_providers();
		
		// JAVA RESOURCES
        m.put(PROVIDER_STRING,new Provider_String());
        m.put(PROVIDER_BOOLEAN,new Provider_Boolean());
        m.put(PROVIDER_INTEGER,new Provider_Integer());
        m.put(PROVIDER_LONG,new Provider_Long());
        m.put(PROVIDER_DOUBLE,new Provider_Double());
        m.put(PROVIDER_SYSTEMPROP,new Provider_SysProp());
        m.put(PROVIDER_SYSTEMENV,new Provider_SysEnv());
        m.put(PROVIDER_OBJECT,new Provider_Object());
        m.put(PROVIDER_CLASS,new Provider_Class());
        
        // APP RESOURCES
        m.put(PROVIDER_ARGUMENT,new Provider_Argument());
        m.put(PROVIDER_PROPERTY,new Provider_Property());
        m.put(PROVIDER_URL,new Provider_Url());
        m.put(PROVIDER_ICON,new Provider_Icon());
        m.put(PROVIDER_SOUND,new Provider_Sound());
        m.put(PROVIDER_POOL,new Provider_Pool());
        m.put(PROVIDER_PROVIDER,new Provider_Provider());
        m.put(PROVIDER_INSIDE,new Provider_Inside());
        
        // SUPPORT RESOURCES
        m.put(PROVIDER_SUPPORTLIST,new Provider_SupList());
        m.put(PROVIDER_SUPPORTSET,new Provider_SupSet());
        m.put(PROVIDER_SUPPORTMAP,new Provider_SupMap());
	}
	
	
	
	
	
	private static class Provider_String implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return key;}
    }
	
	private static class Provider_Boolean implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return new Boolean(key);}
    }
	
	private static class Provider_Integer implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return new Integer(key);}
    }
	
	private static class Provider_Long implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return new Long(key);}
    }
	
	private static class Provider_Double implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return new Double(key);}
    }
	
	
	
	
	
	private static class Provider_SysProp implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return System.getProperty(key);}
    }
	
	private static class Provider_SysEnv implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return System.getenv(key);}
    }
	
	private static class Provider_Object implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return Class.forName(key).newInstance();}
    }
    
    private static class Provider_Class implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return Class.forName(key);}
    }
    
    
    
    
    
    private static class Provider_Argument implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return appArgs[Integer.parseInt(key)];}
    }
    
    private static class Provider_Property implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return getProp(key,null);}
    }
    
    private static class Provider_Url implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return new URL(hasProp(key)?getProp(key):key);}
    }
    
    private static class Provider_Icon extends AbstractResourceProvider
    {
		protected Object retrieveResource(Entity entity, String id, String key) throws Exception
		{return icon1(entity,key);}
    }
    
    private static class Provider_Sound extends AbstractResourceProvider
    {
    	protected Object retrieveResource(Entity entity, String id, String key) throws Exception
        {return sound(entity,key);}
    }
    
    private static class Provider_Pool implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return getPool(key);}
    }
	
    private static class Provider_Provider implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return map_providers().get(key);}
    }
    
    private static class Provider_Inside implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return inside.retrieve(key);}
    }
    
    
    
    
    
    private static class Provider_SupList implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return supList(key);}
    }
    
    private static class Provider_SupSet implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return supSet(key);}
    }
    
    private static class Provider_SupMap implements Retrieve
    {
        public Object retrieve(String key) throws Exception
        {return supMap(key);}
    }
}
