package gus05.manager.gus.kassia.layer3.t36.initresourceprovider.output;


import java.io.PrintStream;
import java.util.Map;
import gus05.framework.core.Entity;
import gus05.framework.features.Give;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class T36 extends AbstractResourceProvider {

	
	
	public static void initResourceProvider_output()
	{
        Map m = map_providers();
        m.put(PROVIDER_OUT,new T36());
	}
    
    
	
	public Object retrieveResource(Entity entity, String id, String key) throws Exception
    {
        if(key.equals("app")) return p_log();
        if(key.equals("null")) return nullPrintStream;
        if(key.equals("system")) return System.out;
        
        if(key.equals("message")) return new MessagePrintStream(entity);
        if(key.equals("warning")) return new WarningPrintStream(entity);
        if(key.equals("debug")) return new DebugPrintStream(entity);
        if(key.equals("")) return new MessagePrintStream(entity);
        
        throw new Exception("Unknown key: ["+key+"]");
    }
	
	
	
	
	private class MessagePrintStream extends PrintStream implements Give
    {
        private String entityName;
        public MessagePrintStream(Entity entity)
        {
            super(nullOutput);
            entityName = entity.getName();
        }
        public void println(String m)
        {printM(this,entityName,m);}

        public void give(Object obj) throws Exception
        {println((String)obj);}
    }
    
    
    
    
    
    private class WarningPrintStream extends PrintStream implements Give
    {
        private String entityName;
        public WarningPrintStream(Entity entity)
        {
            super(nullOutput);
            entityName = entity.getName();
        }
        public void println(String m)
        {printW(this,entityName,m);}

        public void give(Object obj) throws Exception
        {println((String)obj);}
    }
    
    
    
    
    
    
    
    private class DebugPrintStream extends PrintStream implements Give
    {
        private String entityName;
        public DebugPrintStream(Entity entity)
        {
            super(nullOutput);
            entityName = entity.getName();
        }
        public void println(String m)
        {printD(this,entityName,m);}

        public void give(Object obj) throws Exception
        {println((String)obj);}
    }
}
