package gus05.manager.gus.kassia.layer3.t42.initresourceprovider.data;


import java.util.Map;

import gus05.framework.core.Entity;
import gus05.manager.gus.kassia.layer3.KS3_data;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class T42 extends KS3_data {

	
	
	public static void initResourceProvider_data()
	{
		Map m = map_providers();
		
		m.put(PROVIDER_DATALIST, new ResourceProvider_list());
		m.put(PROVIDER_DATASET, new ResourceProvider_set());
		m.put(PROVIDER_DATAMAP, new ResourceProvider_map());
		m.put(PROVIDER_DATATREE, new ResourceProvider_tree());
		
		m.put(PROVIDER_DATALIST_SECURED, new ResourceProvider_list_secured());
		m.put(PROVIDER_DATASET_SECURED, new ResourceProvider_set_secured());
		m.put(PROVIDER_DATAMAP_SECURED, new ResourceProvider_map_secured());
		m.put(PROVIDER_DATATREE_SECURED, new ResourceProvider_tree_secured());
	}
	
	
	
	

	
	private static String formatKey(Entity entity, String id, String key)
	{
		if(key.startsWith("pool")) return key+"."+src(entity,id);
		return key;
	}
	
	
	
	
	private static class ResourceProvider_list extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {return getDataList(PROVIDER_DATALIST+"#"+formatKey(entity,id,key));}
	}
	
	
	private static class ResourceProvider_set extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {return getDataSet(PROVIDER_DATASET+"#"+formatKey(entity,id,key));}
	}
	
	
	private static class ResourceProvider_map extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {return getDataMap(PROVIDER_DATAMAP+"#"+formatKey(entity,id,key));}
	}
	
	
	private static class ResourceProvider_tree extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {return getDataTree(PROVIDER_DATATREE+"#"+formatKey(entity,id,key));}
	}
    
    
    
	private static class ResourceProvider_list_secured extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {return getDataList(PROVIDER_DATALIST_SECURED+"#"+formatKey(entity,id,key));}
	}
	
	
	private static class ResourceProvider_set_secured extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {return getDataSet(PROVIDER_DATASET_SECURED+"#"+formatKey(entity,id,key));}
	}
	
	
	private static class ResourceProvider_map_secured extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {return getDataMap(PROVIDER_DATAMAP_SECURED+"#"+formatKey(entity,id,key));}
	}
	
	
	private static class ResourceProvider_tree_secured extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {return getDataTree(PROVIDER_DATATREE_SECURED+"#"+formatKey(entity,id,key));}
	}
}
