package gus05.manager.gus.kassia.layer3.t49.initresourceprovider.actionbuilder;



import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;

import gus05.framework.core.Entity;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Retrieve;
import gus05.framework.resources.ActionBuilder;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class T49 extends AbstractResourceProvider {

	
	
	public static void initResourceProvider_actionBuilder()
	{map_providers().put(PROVIDER_ACTIONBUILDER,new T49());}

	
    
    
	public Object retrieveResource(Entity entity, String id, String key) throws Exception
    {return new EntityActionBuilder(entity);}
    
    
    
    private class EntityActionBuilder implements ActionBuilder
    {
        private Entity entity;
        public EntityActionBuilder(Entity entity)
        {this.entity = entity;}

        public Action build(String key, Execute execute)
        {return new Action1(entity,key,execute);}
    }
    
    
    
    
    
    
    private class Action1 extends AbstractAction implements Retrieve
    {
        private String actionKey;
        private Execute execute;
        private Entity entity;
        private String actionId;
        
        public Action1(Entity entity, String actionKey, Execute execute)
        {
            this.actionKey = actionKey;
            this.execute = execute;
            this.entity = entity;
            actionId = src(entity,actionKey);
            
            handleAction(this);
        }
        
        public void actionPerformed(ActionEvent e)
        {execute(actionId,execute);}
        
        public String toString()
        {return actionId;}
		
		public Object retrieve(String key) throws Exception
		{
			if(key.equals("execute")) return execute;
			if(key.equals("entity")) return entity;
			if(key.equals("actionKey")) return actionKey;
			if(key.equals("actionId")) return actionId;
			
			if(key.equals("keys"))
				return new String[]{"execute","entity","actionKey","actionId"};
			throw new Exception("Unknown key: ["+key+"]");
		}
    }
    
    
    
    
    
    
    
    private void execute(String actionId, Execute exe)
    {
    	try{exe.execute();}
        catch(Exception e)
        {
        	String message = "Action ID=["+actionId+"] failed to execute";
			err(this,"execute(String,Execute)",new Exception(message,e));
        }
    }
    
    
    
    
    
    private void handleAction(Action action)
    {
    	try
    	{
    		Give g = poolgive(POOL_GIVE_ACTIONHANDLER);
    		if(g!=null) g.give(action);
    	}
    	catch(Exception e)
    	{err(this,"handleAction(Action)",e);}
    }
}
