package gus05.manager.gus.kassia.layer3.t53.initlogfile;

import java.io.File;
import java.io.PrintStream;

import gus05.framework.features.Give;
import gus05.manager.gus.kassia.layer3.KS3_data;

public class T53 extends KS3_data {

	
	public static void initLogFile()
    {
    	try
    	{
    		File logFile = findLogFile();
            if(logFile==null) return;

            if(!logFile.exists()) logFile.createNewFile();
            
            PrintStream log = new PrintStream(logFile,"UTF-8");
            Give g = (Give) p_log();
            g.give(log);
            
            map_files().put(FILEID_LOGFILE, logFile);
            printM(T53.class,"initLogFile()","Log file initialized: ["+logFile+"]");
    	}
    	catch(Exception e)
    	{err(T53.class,"initLogFile()",e);}
    }
	
	
	
    
    private static File findLogFile() throws Exception
    {
        File logFile = file(FILEID_LOGFILE);
        if(logFile!=null)
        {
            File parent = logFile.getParentFile();
            initDir(parent);
            return logFile;
        }
        
        File logDir = file(FILEID_LOGDIR);
        if(logDir==null) return null;
        
        initDir(logDir);
        if(!logDir.canWrite()) throw new Exception("Cannot write inside log dir: ["+logDir+"]");
        
        String appName = getProp_u(PROPKEY_APPNAME);
        String fileName = appName+"_"+now()+".log";
        return new File(logDir,fileName);
    }
}
