package gus05.manager.gus.kassia.layer3.tools;

import gus05.manager.gus.kassia.layer3.KS3_data;

public abstract class AbstractResourceLoader extends KS3_data {

	
	protected void load(String type, String key, String defaultKey) throws Exception
	{
		String seq = getProp(key,defaultKey);
		if(seq.equals("")) return;
		
		String[] sequence = seq.split(";");
        for(int i=0;i<sequence.length;i++)
        {
            String s = sequence[i];
            if(s.startsWith("path.")) load_fromPathID(i,s);
            else load_fromInside(i,s);
        }
	}
	
	private void load_fromInside(int index, String resourceID)
	{
		try{load_fromInside_(index,resourceID);}
		catch(Exception e)
        {err(this,"load_fromInside(String)",e);}
	}
	
	private void load_fromPathID(int index, String pathID)
	{
		try{load_fromPathID_(index,pathID);}
		catch(Exception e)
        {err(this,"load_fromPathID(String)",e);}
	}
	
	
	
	
	protected abstract void load_fromInside_(int index, String resourceID) throws Exception;
	protected abstract void load_fromPathID_(int index, String pathID) throws Exception;
}
