package gus05.manager.gus.kassia.layer3.tools;

import gus05.manager.gus.kassia.layer3.KS3_data;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Map;


public class Tool_debug extends KS3_data {

	
	
	public static void printAppDebugInfo()
    {
    	if(!hasProp(PROPKEY_DEBUGINFO)) return;
    	String debugInfo = getProp(PROPKEY_DEBUGINFO);
    	printAppDebugInfo(p_log(),debugInfo);
    }
	
	
	
	public static void printAppDebugInfo_all()
    {printAppDebugInfo_all(p_log());}
	
	
	
	
	
	public static void printAppDebugInfo(PrintStream p, String debugInfo)
    {
		if(debugInfo.toUpperCase().equals("ALL"))
		{
			printAppDebugInfo_all(p);
			return;
		}
		
    	p.println("");
    	p.println("----------DEBUG INFO----------");
    	p.println("debugInfo: ["+debugInfo+"]");
    	p.println("");
    	
    	// java
    	if(debugInfo.contains("a")) printAppInfo_java(p);
    	// OS
    	if(debugInfo.contains("b")) printAppInfo_OS(p);
    	// arguments
    	if(debugInfo.contains("c")) printAppInfo_args(p);
        // parameters
    	if(debugInfo.contains("d")) printAppInfo_params(p);
        // properties
    	if(debugInfo.contains("e")) printAppInfo_properties(p);
        // fileID
    	if(debugInfo.contains("f")) printAppInfo_files(p);
    	// pool
    	if(debugInfo.contains("g")) printAppInfo_pool(p);
    	// mapping
    	if(debugInfo.contains("h")) printAppInfo_mapping(p);
    	// entities
    	if(debugInfo.contains("i")) printAppInfo_entities(p);
    	// start
    	if(debugInfo.contains("j")) printAppInfo_start(p);
    	// constants
    	if(debugInfo.contains("k")) printAppInfo_constants(p);
    	
    }
	
	
	
	
	public static void printAppDebugInfo_all(PrintStream p)
    {
    	p.println("");
    	p.println("----------DEBUG INFO----------");
    	p.println("debugInfo: ALL");
    	p.println("");
    	
    	// java
    	printAppInfo_java(p);
    	// OS
    	printAppInfo_OS(p);
    	// arguments
    	printAppInfo_args(p);
        // parameters
    	printAppInfo_params(p);
        // properties
    	printAppInfo_properties(p);
        // fileID
    	printAppInfo_files(p);
    	// pool
    	printAppInfo_pool(p);
    	// mapping
    	printAppInfo_mapping(p);
    	// entities
    	printAppInfo_entities(p);
    	// start
    	printAppInfo_start(p);
    	// constants
    	printAppInfo_constants(p);
    }
	
	
	
	
	
	
	private static void printAppInfo_java(PrintStream p)
    {
        String runtimeVersion = System.getProperty("java.runtime.version");
        String homeDir = System.getProperty("java.home");
        String userDir = System.getProperty("user.dir");
        String[] paths = System.getProperty("java.class.path").split(File.pathSeparator);
        String[] ext = System.getProperty("java.ext.dirs").split(File.pathSeparator);
        String sunArchDataModel = System.getProperty("sun.arch.data.model");
        
        p.println("----------JAVA JVM----------");
        p.println(" Java Runtime Version: ["+runtimeVersion+"]");
        p.println(" Java Home Dir: ["+homeDir+"]");
        p.println(" Java User Dir: ["+userDir+"]");
        p.println(" Sun arch data model: ["+sunArchDataModel+"]");
        p.println("");
        p.println(" Java class path: "+paths.length+" path(s)");
        for(int i=0;i<paths.length;i++) p.println("  -path"+i+"=["+paths[i]+"]");
        p.println("");
        p.println(" Java lib ext dirs: "+ext.length+" dir(s)");
        for(int i=0;i<ext.length;i++)
        {
            File extDir = new File(ext[i]);
            p.println("  -dir"+i+": ["+extDir+"]");
            if(!extDir.exists()) p.println("   -does not exist !!");
            else
            {
                File[] jars = extDir.listFiles(jarFileFilter);
                for(int j=0;j<jars.length;j++) p.println("   -jar"+j+": ["+jars[j].getName()+"]");
            }
        }
        p.println("");
    }
	
	
	
	
	private static void printAppInfo_OS(PrintStream p)
    {
		String osName = System.getProperty("os.name");
        String osVersion = System.getProperty("os.version");
        String osArch = System.getProperty("os.arch");
        String userCountry = System.getProperty("user.country");
        String userLanguage = System.getProperty("user.language");
        String userTimezone = System.getProperty("user.timezone");
        String fileEncoding = System.getProperty("file.encoding");
        String fileSeparator = System.getProperty("file.separator");
        
        p.println("----------COMPUTER SYSTEM----------");
        p.println(" Operating System: name=["+osName+"] version=["+osVersion+"] arch=["+osArch+"]");
        p.println(" Country/Language: ["+userCountry+"]/["+userLanguage+"]");
        p.println(" Time Zone: ["+userTimezone+"]");
        p.println(" File encoding: ["+fileEncoding+"]");
        p.println(" File separator: ["+fileSeparator+"]");
        p.println("");
    }
	
	
	
    
    private static void printAppInfo_args(PrintStream p)
    {
    	p.println("----------APP ARGS----------");
        p.println(" App args: "+appArgs.length+" arguments  (args delimiter: semicolon)");
        for(int i=0;i<appArgs.length;i++) p.println("  -arg"+i+"=["+appArgs[i]+"]");
        p.println("");
    }
    
    private static void printAppInfo_params(PrintStream p)
    {
    	p.println("----------APP PARAMS----------");
        p.println(" App params: "+params.size()+" parameters");
        ArrayList paramKeys = new ArrayList(params.keySet());
        Collections.sort(paramKeys);
        for(int i=0;i<paramKeys.size();i++)
        {
            String k = (String) paramKeys.get(i);
            p.println("  -["+k+"]=["+params.get(k)+"]");
        }
        p.println("");
    }
    
    private static void printAppInfo_properties(PrintStream p)
    {
    	p.println("----------APP PROPERTIES----------");
        p.println(" App props: "+map_props().size()+" properties");
        ArrayList propKeys = new ArrayList(map_props().keySet());
        Collections.sort(propKeys);
        for(int i=0;i<propKeys.size();i++)
        {
            String k = (String) propKeys.get(i);
            p.println("  -["+k+"]=["+getProp(k)+"]");
        }
        p.println("");
    }
    
    private static void printAppInfo_files(PrintStream p)
    {
    	Map m = map_files();
    	p.println("----------APP FILEIDS----------");
        p.println(" App file ids: "+m.size()+" ids");
        ArrayList fileIDKeys = new ArrayList(m.keySet());
        Collections.sort(fileIDKeys);
        for(int i=0;i<fileIDKeys.size();i++)
        {
            String k = (String) fileIDKeys.get(i);
            File f = file(k);
            if(f.exists()) p.println("  -["+k+"]=["+f+"]");
            else p.println("  -["+k+"]=["+f+"] (does not exist)");
        }
        p.println("");
    }
    
    private static void printAppInfo_pool(PrintStream p)
    {
    	p.println("----------APP POOL----------");
        p.println(" App pool: "+pool.size()+" objects");
        ArrayList poolKeys = new ArrayList(pool.keySet());
        Collections.sort(poolKeys);
        for(int i=0;i<poolKeys.size();i++)
        {
            String k = (String) poolKeys.get(i);
            p.println("  -["+k+"]=["+getPool(k).getClass().getName()+"]");
        }
        p.println("");
    }
    
    private static void printAppInfo_mapping(PrintStream p)
    {
    	p.println("----------APP MAPPING----------");
        p.println(" App mapping: "+mapping.size()+" mappings");
        ArrayList mappingKeys = new ArrayList(mapping.keySet());
        Collections.sort(mappingKeys);
        for(int i=0;i<mappingKeys.size();i++)
        {
            String k = (String) mappingKeys.get(i);
            p.println("  -["+k+"]=["+mapping.get(k)+"]");
        }
        p.println("");
    }
    
    private static void printAppInfo_entities(PrintStream p)
    {
    	p.println("----------APP INTERNAL ENTITIES----------");
        p.println(" App entities: "+entities.size()+" entities");
        ArrayList entitiesKeys = new ArrayList(entities.keySet());
        Collections.sort(entitiesKeys);
        for(int i=0;i<entitiesKeys.size();i++)
        {
            String k = (String) entitiesKeys.get(i);
            p.println("  -["+k+"]=["+entities.get(k)+"]");
        }
        p.println("");
    }
    
    private static void printAppInfo_start(PrintStream p)
    {
    	p.println("----------APP START LIST----------");
        p.println(" App start list: "+startedList().size()+" entities");
        for(int i=0;i<startedList().size();i++)
        p.println("  -"+i+"=["+startedList().get(i)+"]");
        p.println("");
    }
    
    private static void printAppInfo_constants(PrintStream p)
    {
    	p.println("----------APP CONSTANTS----------");
        Map m = poolmap(POOL_MAP_CONSTANTS);
    	p.println(" App constants: "+m.size()+" values");
        ArrayList keys = new ArrayList(m.keySet());
        Collections.sort(keys);
        for(int i=0;i<keys.size();i++)
        {
            String k = (String) keys.get(i);
            p.println("  -["+k+"]=["+m.get(k)+"]");
        }
        p.println("");
    }
}
