package gus05.manager.gus.kassia.layer3.v05.decorateframe;

import java.awt.DisplayMode;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Toolkit;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import gus05.framework.features.Give;
import gus05.manager.gus.kassia.layer3.KS3_data;

public class V05 extends KS3_data {

	
	public static void decorateFrame()
    {
    	try
    	{
    		JFrame f = mainFrame();
    		if(f==null) return;
    		
    		Give g = (Give) findElement(POOL_GIVE_CUSTOMIZEFRAME);
    		if(g!=null) g.give(f);
    		else decorateFrame_default();
    	}
    	catch(Exception e)
    	{err(V05.class,"decorateFrame()",e);}
    }
    
	
	
	
    
    private static void decorateFrame_default()
    {
    	initFrameSize();
    	initFrameLocation();
    	initFrameTitle();
    	initFrameIcon();
    	initFrameLookAndFeel();
    	initFrameFeatures();
    }
    
    
    
    private static void initFrameSize()
    {
        if(hasProp(PROPKEY_APPSIZE))
        {
            String info = getProp(PROPKEY_APPSIZE);
            initFrameSize(info);
        }
        else mainFrame().setSize(FRAMEWIDTH_DEFAULT,FRAMEHEIGHT_DEFAULT);
    }
    
    private static void initFrameSize(String info)
    {
    	if(info.startsWith("*"))
        {
    		mainFrame().setResizable(false);
            info = info.substring(1);
        }
        if(info.equals("pack"))
        {
        	mainFrame().pack();
        	return;
        }
        if(info.equals("screen"))
        {
            GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment(); 
            GraphicsDevice device = env.getDefaultScreenDevice();
            DisplayMode displayMode = device.getDisplayMode();
            
            int H = displayMode.getHeight();
            int W = displayMode.getWidth();
            mainFrame().setSize(W-50,H-100);
            return;
        }
        String[] n = info.split(" ");
        int X = Integer.parseInt(n[0]);
        int Y = Integer.parseInt(n[1]);
        mainFrame().setSize(X,Y);
    }
    
    
    private static void initFrameLocation()
    {
    	if(hasProp(PROPKEY_APPLOCATION))
    	{
            String info = getProp(PROPKEY_APPLOCATION);
            initFrameLocation(info);
        }
    	else mainFrame().setLocationRelativeTo(null);
    }
    
    private static void initFrameLocation(String info)
    {
    	String[] n = info.split(" ");
        int X = Integer.parseInt(n[0]);
        int Y = Integer.parseInt(n[1]);
        mainFrame().setLocation(X,Y);
    }
    
    
    private static void initFrameTitle()
    {
    	if(!hasProp(PROPKEY_APPTITLE)) return;
        String title = getProp(PROPKEY_APPTITLE);
        if(booleanProp(PROPKEY_APPTITLEVER,false))
        	title = title+" "+getProp(PROPKEY_APPVERSION);
        mainFrame().setTitle(title);
    }
    
    
    private static void initFrameIcon()
    {
        if(!hasProp(PROPKEY_APPICON)) return;
        String iconID = getProp(PROPKEY_APPICON);
        ImageIcon icon = (ImageIcon) icon(iconID);    
        if(icon!=null) mainFrame().setIconImage(icon.getImage());
    }
    
    
    
    private static void initFrameLookAndFeel()
    {
    	try
    	{
    		if(!hasProp(PROPKEY_APPLAF)) return;
        	String laf = getProp(PROPKEY_APPLAF);
    		UIManager.setLookAndFeel(laf);
            SwingUtilities.updateComponentTreeUI(mainFrame());
    	}
    	catch(Exception e)
    	{err(V05.class,"initFrameLookAndFeel()",e);}
    }
    
    
    private static void initFrameFeatures()
    {
    	if(booleanProp(PROPKEY_APPUNDECORATED,false))
        	mainFrame().setUndecorated(true);
        
        if(booleanProp(PROPKEY_APPALWAYSONTOP,false))
        	mainFrame().setAlwaysOnTop(true);
        
        if(booleanProp(PROPKEY_APPDYNAMICLAYOUT,false))
        	Toolkit.getDefaultToolkit().setDynamicLayout(true);
    }
}
